<?php
if (!defined( "WHMCS" )) {
    die("This file cannot be accessed directly");
}
require_once dirname( __FILE__ ) . '/include/cyberssl_api.class.php';
global $CONFIG, $_LANG, $smarty, $whmcs;
/**
 * Initialisate language always while loading this file.
 */
$langFile = dirname( __FILE__ ) . '/lang/' . ((isset($_SESSION['language'])) ? $_SESSION['language'] : '') . '.php';
if (!file_exists( $langFile )) {
    $langFile = dirname( __FILE__ ) . '/lang/' . $whmcs->get_config( 'Language' ) . '.php';

    if (!file_exists( $langFile )) {
        $langFile = dirname( __FILE__ ) . '/lang/english.php';
    }
}
require_once($langFile);
if (isset($smarty)) {
    $smarty->assign( 'LANG', $_LANG );
}

function _cyberssl_get_user($id)
{
    $r = select_query( 'tblclients', '*', array( 'id' => $id ) );
    $user_array = mysql_fetch_assoc( $r );

    return "user_id: " . $id . " ; name: " . $user_array["firstname"] . " " . $user_array["lastname"];
}

function _cyberssl_log($action, $message, $type, $user_id = 'Admin')
{
    if ($type == "error") {
        $message_type = "Error_Message";
    } else {
        $message_type = "Message";
    }
    if ($user_id != 'Admin') {
        $user_id = _cyberssl_get_user( $user_id );
    }
    logActivity( "Module CyberSSL - User [ " . $user_id . " ] , Action = " . $action . " , "
        . $message_type . " = " . $message );
}

function _cyberssl_WebsoftConvert($soft_id)
{
    $whmcs_soft["1001"] = 1;
    $whmcs_soft["1002"] = 5;
    $whmcs_soft["1003"] = 5;
    $whmcs_soft["1004"] = 10;
    $whmcs_soft["1005"] = 11;
    $whmcs_soft["1006"] = 1;
    $whmcs_soft["1031"] = 2;
    $whmcs_soft["1029"] = 12;
    $whmcs_soft["1032"] = 1;
    $whmcs_soft["1007"] = 13;
    $whmcs_soft["1008"] = 13;
    $whmcs_soft["1009"] = 14;
    $whmcs_soft["1010"] = 15;
    $whmcs_soft["1011"] = 16;
    $whmcs_soft["1012"] = 17;
    $whmcs_soft["1013"] = 7;
    $whmcs_soft["1014"] = 7;
    $whmcs_soft["1015"] = 18;
    $whmcs_soft["1016"] = 18;
    $whmcs_soft["1017"] = 1;
    $whmcs_soft["1018"] = 14;
    $whmcs_soft["1030"] = 3;
    $whmcs_soft["1019"] = 1;
    $whmcs_soft["1020"] = 1;
    $whmcs_soft["1021"] = 9;
    $whmcs_soft["1022"] = 1;
    $whmcs_soft["1023"] = 1;
    $whmcs_soft["1024"] = 15;
    $whmcs_soft["1025"] = 1;
    $whmcs_soft["1026"] = 19;
    $whmcs_soft["1027"] = 1;
    $whmcs_soft["1028"] = 20;
    $whmcs_soft["1000"] = 1;
    if (!$whmcs_soft[ $soft_id ]) {
        return 1;
    }

    return $whmcs_soft[ $soft_id ];
}

function cyberssl_MetaData()
{
    return array(
        'DisplayName'    => 'CyberSSL',
        'APIVersion'     => '1.1', // Use API Version 1.1
        'RequiresServer' => false, // Set true if module requires a server to work
    );
}

function _cyberssl_GetSSLcertificates()
{
    $api = new CyberSSL_api();
    //$productRequest = curlCall( 'https://api.cyberssl.com/v1/ssl_certificates' );
    //$certList = json_decode( $productRequest, true );
    $ssl_products = $api->ssl_certificates();

    if (is_array( $ssl_products )) {
        
        
        return $ssl_products;
    }
    
    

    return array();
}

function cyberssl_ConfigOptions()
{
    global $packageconfigoption;


    $products = _cyberssl_GetSSLcertificates();
    

    $emailQuery = select_query( 'tblemailtemplates', '*', array( 'name' => 'CyberSSL Activation Required' ) );

    if (mysql_num_rows( $emailQuery ) < 1) {
        full_query( 'INSERT INTO tblemailtemplates (type, name, subject, message, fromname, fromemail, disabled, custom, language, copyto, plaintext) VALUES ("product", "CyberSSL Activation Required", "SSL Certificate Activation Required",
        "<p>Dear {$client_name},</p><p>Thank you for your order. <br />You need to pass the activation process, before you can use your SSL Certificate. You can do that at the following link: </p><p>{$ssl_configuration_link}</p><p>Instructions are provided throughout the entire activation process. Anyway, if you experience any problems or have any questions, please feel free to open a ticket and we will be more than glad to assist you.</p><p>{$signature}</p>", "", "", "", "", "", "", "0")' );
    }


    if (is_array( $products )) {
        foreach ($products as $cert => $details) {
            if ($details['product_id']) {
                $certTypeList_array[] = $details['name'] . " - (ID:" . $details['product_id'] . ")";
            }
        }
    }
    
 
    
    $certTypeList = implode( ",", $certTypeList_array );

    if (isset($packageconfigoption[1]) && isset($packageconfigoption[2])) {
        if (!empty($packageconfigoption[1]) && !empty($packageconfigoption[2])) {

            $api = new CyberSSL_api( $packageconfigoption[2] );
            if (!$api->auth( $packageconfigoption[1] )) {
                echo '<div class="errorbox"><strong><span class="title">API credentials invalid</span></strong><br>Recheck your API credentials (Api Key), as we could not authenticate to the CyberSSL API. </div>';
            }


        }
    }

    /* $additionalNotes = '<script type="text/javascript">
        $(document).ready(function() {

            $("#techemail").parent().parent("tr").prev().after("<tr><td><br /><tr><td colspan=4><div id=\"newtechnote\" style=\"text-align:center;\"></td></tr>");
            $("#newtechnote").html($("#tech_note").html());
            $("#tech_note").html("");
        });
        </script>

        <div id="tech_note">
          If you want to use a <b>custom technical contact</b> for SSL Certificates, then please fill in all the fields below.
        </div>
        ';
    */

    return array(
        'API key' => array(
            'Type'        => 'text',
            'Size'        => '25',
            'Description' => ''
        ),
        'Mode'    => array(
            'Type'    => 'dropdown',
            'Options' => 'production,sandbox'
        ),

        'SSL Certificate Type' => array(
            'Type'    => 'dropdown',
            'Options' => $certTypeList
        )
    );
}

/**
 * CreateAccount() function is called when an new order is being processed.
 *
 * @param $params
 *
 * @return string
 * @throws
 */
function cyberssl_CreateAccount($params)
{
    global $CONFIG;
    try {
        $orderQuery = select_query( 'tblsslorders', '*', array( 'serviceid' => $params['serviceid'] ) );

        if (mysql_num_rows( $orderQuery ) >= 1) {
            throw new Exception( 'An SSL Order already exists for this order' );
        }

        if (isset($params['configoptions']['Certificate Type'])) {
            $certType = $params['configoptions']['Certificate Type'];
        } else {
            $certTypeSplit = explode( '(ID:', $params['configoption3'] );
            $certType = substr( $certTypeSplit[1], 0, -1 );
        }

        $queryData = array(
            'userid'    => $params['clientsdetails']['userid'],
            'serviceid' => $params['serviceid'],
            'module'    => 'cyberssl',
            'certtype'  => $certType,
            'status'    => 'Incomplete'
        );

        if (version_compare( '4.5.2', $CONFIG['Version'], '<=' )) {
            $queryData['status'] = 'Awaiting Configuration';
        }

        $sslOrderID = insert_query( 'tblsslorders', $queryData );

        if (!$sslOrderID) {
            throw new Exception( 'Unable to insert a new SSL order' );
        }

        $sendWelcome = false;

        if (!empty($_POST) && !empty($_POST['vars']['products'][ $params['serviceid'] ]) && !empty($_POST['vars']['products'][ $params['serviceid'] ]['sendwelcome'])) {
            $sendWelcome = true;
        }

        if (empty($_POST['vars']['products'][ $params['serviceid'] ])) {
            $productQuery = mysql_query( 'SELECT autosetup FROM tblproducts WHERE id = ' . $params['packageid'] . ' LIMIT 1' );
            $productFetch = mysql_fetch_assoc( $productQuery );

            $sendWelcome = ($productFetch['autosetup'] == 'payment' || $productFetch['autosetup'] == 'order');
        }

        if ($sendWelcome) {
            $sslConfigurationLink = (($CONFIG['SystemSSLURL'] == '') ? $CONFIG['SystemURL'] : $CONFIG['SystemSSLURL']) . '/configuressl.php?cert=' . md5( $sslOrderID );
            $sslConfigurationLink = '<a href="' . $sslConfigurationLink . '">' . $sslConfigurationLink . '</a>';
            sendMessage( 'CyberSSL Activation Required', $params['serviceid'], array( 'ssl_configuration_link' => $sslConfigurationLink ) );
        }
    } catch (Exception $e) {
        _cyberssl_log("CreateAccount",  $e->getMessage(),"error", $params["userid"]);
        // Record the error in WHMCS's module log.
        logModuleCall(
            'CyberSSL',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getTraceAsString()
        );

        return $e->getMessage();
    }

    return 'success';
}

/**
 * ClientArea() function will return an array with the requested information for WHMCS, this will be used to display the right content within the clientarea product/order page.
 *
 * @param $params
 *
 * @return array|mixed
 */
function cyberssl_ClientArea($params)
{
    global $_LANG, $CONFIG;

    try {
        $orderQuery = full_query( 'SELECT * FROM tblsslorders WHERE serviceid = ' . $params['serviceid'] . ' AND (status = "Incomplete" OR status = "Awaiting Configuration" OR status = "Completed")' );

        if (mysql_num_rows( $orderQuery ) < 1) {
            throw new Exception( $_LANG['cyberssl_no_certificate_exists'] );
        }

        $orderFetch = mysql_fetch_assoc( $orderQuery );

        if ($orderFetch['status'] != 'Completed') {
            return array(
                'templatefile' => 'templates/clientarea',
                'vars'         => array(
                    'cyberssl_status'     => $_LANG['cyberssl_status_awaiting_configuration'],
                    'cyberssl_raw_status' => 'awaiting_configuration',
                    'configuration_url'   => (($CONFIG['SystemSSLURL'] == '') ? $CONFIG['SystemURL'] : $CONFIG['SystemSSLURL']) . '/configuressl.php?cert=' . md5( $orderFetch['id'] )
                )
            );
        }
        update_query( 'tblhosting', array( 'domainstatus' => 'Active'), array( 'id' => $params['serviceid'] ) );
        $certQuery = full_query( 'SELECT * FROM tblhosting WHERE id = ' . $params['serviceid'] . ' AND billingcycle IN ("Annually", "Biennially", "Triennially") LIMIT 1' );
        $certFetch = mysql_fetch_assoc( $certQuery );

        $api = new CyberSSL_api( $params['configoption2'] );
        if (!$api->auth( $params['configoption1'] )) {
            throw new Exception( "api auth error" );
        }
        $order_status = $api->order_status( $orderFetch['remoteid'] );

        if (!$api->response_success) {
            throw new Exception( $api->error_message );
        }


        if ($api->response_success) {

            if ($order_status['status'] == 'Activated' && $certFetch) {
                $expiresDate = $order_status['valid_till'];

                full_query( 'UPDATE tblhosting SET nextduedate = "' . $expiresDate . '", nextinvoicedate = "' . $expiresDate . '" WHERE id = ' . $params['serviceid'] );
            }

            $status = $order_status['status'];
             
            if (isset($_LANG[ 'cyberssl_status_' . $status ])) {
                $status = $_LANG[ 'cyberssl_status_' . $status ];
            }
        }

        if (isset($_GET['custom_page'])) {

            if (function_exists( 'cyberssl_page_' . $_GET['custom_page'] )) {
                return call_user_func_array( 'cyberssl_page_' . $_GET['custom_page'], array( $params, $order_status, $orderFetch ) );
            } else {
                return array(
                    'templatefile' => 'templates/notification',
                    'vars'         => array(
                        'status'      => 'error',
                        'title'       => $_LANG['cyberssl_page_not_found_title'],
                        'description' => $_LANG['cyberssl_page_not_found_desc']
                    )
                );
            }

        } else {
		    
            return array(
                'tabOverviewReplacementTemplate' => 'templates/clientarea',
                'vars'         => array(
                    'cyberssl_status' => $status,
                    'cyberssl_order'  => $order_status
                )
            );
        }
    } catch (Exception $e) {
        _cyberssl_log("ClientArea",  $e->getMessage(),"error", $params["userid"]);
        logModuleCall(
            'CyberSSL',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getMessage() . "\n" . $e->getTraceAsString()
        );
        if ($e->getMessage() == "api auth error") {
            $error_message = $_LANG['cyberssl_technical_error_occured'];
        } else {
            $error_message = $e->getMessage();
        }

        return array(
            'templatefile' => 'templates/notification',
            'vars'         => array(
                'status'      => 'error',
                'title'       => $_LANG['cyberssl_error_occured'],
                'description' => $error_message
            )
        );
    }
}

/**
 * SSLStepOne() function will prepare step one for the SSL configuration page.
 *
 * @param $params
 *
 * @return array
 */
function cyberssl_SSLStepOne($params)
{
    try {
        global $_LANG;

        $orderID = $params['remoteid'];

        $api = new CyberSSL_api( $params['configoption2'] );
        if (!$api->auth( $params['configoption1'] )) {
            throw new Exception( "Can't connect to CyberSSL API" );
        }
        $productResult = $api->get_ssl_product_details( $params['certtype'] );

        if (!$productResult) {
            throw new Exception( "Can't get product details from CyberSSL API" );
        } else {
            $_SESSION['cybersslcert'][ $orderID ]['product_details'] = $productResult;
        }

        if ($_SESSION['cybersslcert'][ $orderID ]['product_details']['is_multi_domain']) {


            foreach ($params['configoptions'] as $k => $v) {
                if (stripos( $k, 'addon domains' ) !== false) {
                    $sanOption = $k;
                    break;
                }
                if (stripos( $k, 'Addon domains' ) !== false) {
                    $sanOption = $k;
                    break;
                }
                if (stripos( $k, 'Addon Domains' ) !== false) {
                    $sanOption = $k;
                    break;
                }
                if (stripos( $k, 'SAN' ) !== false) {
                    $sanOption = $k;
                    break;
                }
                if (stripos( $k, 'san' ) !== false) {
                    $sanOption = $k;
                    break;
                }
                if (stripos( $k, 'addon' ) !== false) {
                    $sanOption = $k;
                    break;
                }
                if (stripos( $k, 'additional domains' ) !== false) {
                    $sanOption = $k;
                    break;
                }
                if (stripos( $k, 'Additional domains' ) !== false) {
                    $sanOption = $k;
                    break;
                }
                 if (stripos( $k, 'Additional Domains' ) !== false) {
                    $sanOption = $k;
                    break;
                }
                if (stripos( $k, 'additional' ) !== false) {
                    $sanOption = $k;
                    break;
                }
               if (stripos( $k, 'Additional' ) !== false) {
                    $sanOption = $k;
                    break;
                } 
                  if (stripos( $k, 'addon' ) !== false) {
                    $sanOption = $k;
                    break;
                }
               
                if (stripos( $k, 'Addon' ) !== false) {
                    $sanOption = $k;
                    break;
                }
               
                if (stripos( $k, 'domain' ) !== false) {
                    $sanOption = $k;
                    break;
                }
                if (stripos( $k, 'domains' ) !== false) {
                    $sanOption = $k;
                    break;
                }
                if (stripos( $k, 'Domain' ) !== false) {
                    $sanOption = $k;
                    break;
                }
                if (stripos( $k, 'Domains' ) !== false) {
                    $sanOption = $k;
                    break;
                }
            }


            if (!$sanOption) {
                $sanOption = 'SAN';
            }

            $addon_domains = intval($params['configoptions'][ $sanOption ]);


            if (isset($params['configoptions'][ $sanOption ])) {
                $sanMax = $_SESSION['cybersslcert'][ $orderID ]['product_details']['multidomains_included'] + $addon_domains - 1;
            } else {
                $sanMax = $_SESSION['cybersslcert'][ $orderID ]['product_details']['multidomains_included'] - 1;
            }

            $_SESSION['cybersslcert'][ $orderID ]['san_total'] = $sanMax;

        }
          if ($_SESSION['cybersslcert'][ $orderID ]['product_details']['is_multi_domain']) {   
         $returnValues['additionalfields'][ $_LANG['cyberssl_additional_domains'] ] = array(
                'additional_domains_list'        => array(
                    'FriendlyName' => $_LANG['cyberssl_addon_domains'],
                    'Type'         => 'text',
                    'Size'         => '75',
                    'Description'  => '',
                    'Required'     => false
                ) );      
            
            }
        if ($_SESSION['cybersslcert'][ $orderID ]['product_details']['organization_required']) {

            $returnValues['additionalfields'][ $_LANG['cyberssl_organization_data'] ] = array(
                'org_name'        => array(
                    'FriendlyName' => $_LANG['cyberssl_organization_company_name'],
                    'Type'         => 'text',
                    'Size'         => '30',
                    'Description'  => '',
                    'Required'     => true
                ),
                'org_division'    => array(
                    'FriendlyName' => $_LANG['cyberssl_organization_division'],
                    'Type'         => 'text',
                    'Size'         => '30',
                    'Description'  => $_LANG['cyberssl_organization_division_or_department_desc'],
                    'Required'     => true
                ),
                'org_addressline' => array(
                    'FriendlyName' => $_LANG['cyberssl_organization_address'],
                    'Type'         => 'text',
                    'Size'         => '50',
                    'Description'  => '',
                    'Required'     => true
                ),
                'org_city'        => array(
                    'FriendlyName' => $_LANG['cyberssl_organization_city'],
                    'Type'         => 'text',
                    'Size'         => '30',
                    'Description'  => '',
                    'Required'     => true
                ),
                'org_region'      => array(
                    'FriendlyName' => $_LANG['cyberssl_organization_state_province'],
                    'Type'         => 'text',
                    'Size'         => '30',
                    'Description'  => '',
                    'Required'     => true
                ),
                'org_postalcode'  => array(
                    'FriendlyName' => $_LANG['cyberssl_organization_postal_code'],
                    'Type'         => 'text',
                    'Size'         => '30',
                    'Description'  => '',
                    'Required'     => true
                ),
                'org_country'     => array(
                    'FriendlyName' => $_LANG['cyberssl_organization_country'],
                    'Type'         => 'country',
                    'Description'  => '',
                    'Required'     => true
                ),
                'org_phone'       => array(
                    'FriendlyName' => $_LANG['cyberssl_organization_phone_number'],
                    'Type'         => 'text',
                    'Size'         => '30',
                    'Description'  => '',
                    'Required'     => true
                )
            );

        }

        return $returnValues;
    } catch (Exception $e) {
        _cyberssl_log("SSLStepOne",  $e->getMessage(),"error", $params["userid"]);
        logModuleCall(
            'CyberSSL',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getMessage() . "\n" . $e->getTraceAsString()
        );
        exit;
    }
}
                          
/**
 * SSLStepTwo() function will check everything from step one and prepare step two for the SSL configuration page.
 *
 * @param $params
 *
 * @return array
 */
function cyberssl_SSLStepTwo($params)
{
    try {
        global $_LANG;

        $orderID = $params['remoteid'];

        if (empty($params['firstname'])) {
            $returnValues['error'] .= '- ' . $_LANG['cyberssl_error_firstname_missing'] . '<br/>';
        }

        if (empty($params['lastname'])) {
            $returnValues['error'] .= '- ' . $_LANG['gogetssl_error_lastname_missing'] . '<br/>';
        }

        if (empty($params['email'])) {
            $returnValues['error'] .= '- ' . $_LANG['cyberssl_error_e-mail_missing'] . '<br/>';
        }

        if (empty($params['address1'])) {
            $returnValues['error'] .= '- ' . $_LANG['cyberssl_error_address_missing'] . '<br/>';
        }

        if (empty($params['city'])) {
            $returnValues['error'] .= '- ' . $_LANG['cyberssl_error_city_missing'] . '<br/>';
        }

        if (empty($params['state'])) {
            $returnValues['error'] .= '- ' . $_LANG['cyberssl_error_state_missing'] . '<br/>';
        }

        if (empty($params['country'])) {
            $returnValues['error'] .= '- ' . $_LANG['cyberssl_error_country_missing'] . '<br/>';
        }

        if (empty($params['phonenumber'])) {
            $returnValues['error'] .= '- ' . $_LANG['cyberssl_error_phone_missing'] . '<br/>';
        }

        if ($_SESSION['cybersslcert'][ $orderID ]['product_details']['organization_required']) {

            if (empty($params['orgname'])) {
                $returnValues['error'] .= '- ' . $_LANG['cyberssl_error_organization_missing'] . '<br/>';
            }


            if (empty($params['jobtitle'])) {
                $returnValues['error'] .= '- ' . $_LANG['cyberssl_error_job_Title_missing'] . '<br/>';
            }

        } else {

            if (empty($params['jobtitle'])) {
                $params['jobtitle'] = 'n/a';
            }

        }

        if (isset($returnValues['error'])) {
            return $returnValues;
        }


        $api = new CyberSSL_api( $params['configoption2'] );
        if (!$api->auth( $params['configoption1'] )) {
            throw new Exception( "api auth error" );
        }

      
       
       
        if (!$api->validate_csr( array(
            'csr'        => $params['csr'],
            'product_id' => $params['certtype'],
            'addon_domains' => $params['fields']['additional_domains_list']
        ) )
        ) {
            throw new Exception( $api->error_message );
            
        } else {
            $csrData = $api->response['csr'];
            $sanData = $api->response["additional_domains"];
              
            $_SESSION['cybersslcert'][ $orderID ]['csr_result'] = $csrData;
        }

         
        if ($_SESSION['cybersslcert'][ $orderID ]['product_details']['is_multi_domain']) {
            if (count($sanData)>0) {   
                  //_cyberssl_log("SSLStepTwo",  $_SESSION['cybersslcert'][ $orderID ]['san_total'],"error", $params["userid"]);
                $sanMax = $_SESSION['cybersslcert'][ $orderID ]['san_total'];
                if ($sanMax < count( $sanData )) {
                    return array( 'error' => sprintf( $_LANG['cyberssl_san_max_count_error'], $sanMax + 1 ) );
                }
            }
        }

        $sanData_string = implode(",", $sanData);

        $returnValues['displaydata']['Domain Name'] = $csrData['common_name'];
        
        //if(count( $sanData )>0) { $returnValues['displaydata']['SAN'] = $sanData_string;  }
        
        
        $returnValues['displaydata']['Organization'] = $csrData['organization'];
        //$returnValues['displaydata']['Organization Unit'] = $csrData['department'];
        //$returnValues['displaydata']['Email'] = $csrData['email'];
        $returnValues['displaydata']['Locality'] = $csrData['city'];
        $returnValues['displaydata']['State'] = $csrData['state'];
        $returnValues['displaydata']['Country'] = $csrData['country'];


        if ($_SESSION['cybersslcert'][ $orderID ]['product_details']['is_multi_domain']) {
            $approverEmails = array( "admin@", "administrator@", "webmaster@", "hostmaster@", "postmaster@" );
            for ($i = 0; $i < count( $csrSans ); $i++) {
                $san = $csrSans[ $i ];
                $sans .= $san . ',';
            }
            $sans = substr( $sans, 0, -1 );
        } else {
            $approverEmails = $api->get_dv_options_csr( array(
                'csr'        => $params['csr'],
                'product_id' => $params['certtype'],
                'dv_method'  => "email"
            ) );
            $approverEmails = $approverEmails["email"][ $csrData['common_name'] ];
        }

        $returnValues['approveremails'] = $approverEmails;

        update_query( 'tblhosting', array( 'domain' => $returnValues['displaydata']['Domain Name'] ), array( 'id' => $params['serviceid'] ) );

        $_SESSION['cybersslcert'][ $orderID ]['csr'] = $params['csr'];
        $_SESSION['cybersslcert'][ $orderID ]['address1'] = $params['address1'];
        $_SESSION['cybersslcert'][ $orderID ]['postcode'] = $params['postcode'];

        $api_post_fields = array();
        $api_post_fields['product_id'] = $params['certtype'];


        $api_post_fields['period'] = _cyberssl_GetPeriod( (int)$params['serviceid'] );
        $api_post_fields['software_id'] = _cyberssl_WebsoftConvert( $params['servertype'] );
        $api_post_fields['csr'] = $params['csr'];
        if ($_SESSION['cybersslcert'][ $orderID ]['product_details']['is_multi_domain']) {
            $api_post_fields['dns_names'] = $sans;
        }

        $contactTypes = array( 'admin_', 'tech_' );


        foreach ($contactTypes as $contactType) {
            $api_post_fields[ $contactType . 'firstname' ] = $params['firstname'];
            $api_post_fields[ $contactType . 'lastname' ] = $params['lastname'];
            $api_post_fields[ $contactType . 'organization' ] = $params['orgname'];
            $api_post_fields[ $contactType . 'title' ] = $params['jobtitle'];
            $api_post_fields[ $contactType . 'address1' ] = $params['address1'];
            $api_post_fields[ $contactType . 'address2' ] = $params['address2'];
            $api_post_fields[ $contactType . 'city' ] = $params['city'];
            $api_post_fields[ $contactType . 'region' ] = $params['state'];
            $api_post_fields[ $contactType . 'postalcode' ] = $params['postcode'];
            $api_post_fields[ $contactType . 'country' ] = $params['country'];
            $api_post_fields[ $contactType . 'phone' ] = $params['phonenumber'];
            $api_post_fields[ $contactType . 'fax' ] = (($params['faxnumber'] != '') ? $params['faxnumber'] : $params['phonenumber']);
            $api_post_fields[ $contactType . 'email' ] = $params['email'];
        }


        if (!empty($params['fields'])) {
            foreach ($params['fields'] as $k => $v) {
                $api_post_fields[ $k ] = $v;
            }
        }

        $_SESSION['cybersslcert'][ $orderID ]['order_details'] = $api_post_fields;

        return $returnValues;

    } catch (Exception $e) {
        _cyberssl_log("SSLStepTwo",  $e->getMessage(),"error", $params["userid"]);
        logModuleCall(                          
            'CyberSSL',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getMessage() . "\n" . $e->getTraceAsString()
        );
        if ($e->getMessage() == "api auth error") {
            return array( 'error' => $_LANG['cyberssl_technical_error_occured'] );
        }

        return array( 'error' => $e->getMessage() );
    }
}

/**
 * SSLStepThree() function will check everything from step two and activates SSL certificate.
 *
 * @param $params
 *
 * @return array
 */
function cyberssl_SSLStepThree($params)
{

    try {
        global $_LANG;

        $orderID = $params['remoteid'];
        $returnValues = array();

        if (empty($params['approveremail'])) {
            return array( 'error' => $_LANG['cyberssl_dv_email_required'] );
        }

        $orderQuery = select_query( 'tblsslorders', '*', array( 'serviceid' => $params['serviceid'] ) );
        $orderFetch = @mysql_fetch_assoc( $orderQuery );


        if ($orderFetch["status"] == "Completed") {
            unset($_SESSION['cybersslcert']);
            throw new Exception( $_LANG['cyberssl_order_already_configured'] );
        }


        if ($orderFetch['remoteid'] > 1) {
            $reissue = true;
        }

        foreach ($_SESSION['cybersslcert'][ $orderID ]['order_details'] as $k => $v)
            $api_post_fields[ $k ] = $v;

        $sansEmails = '';

        if ($_SESSION['cybersslcert'][ $orderID ]['product_details']['is_multi_domain']) {
            $sansDomains = explode( ',', $api_post_fields['dns_names'] );

            if (strlen( $api_post_fields['dns_names'] ) > 4) {
                foreach ($sansDomains as $san) {
                    $san = trim( $san );
                    $sansEmails .= $params['approveremail'] . $san . ',';
                }
                $san_emails = ',' . substr( $sansEmails, 0, -1 );
            }
            $approveremail = $params['approveremail'] . $params["domain"];
        } else {
            $approveremail = $params['approveremail'];
        }

        $api = new CyberSSL_api( $params['configoption2'] );
        if (!$api->auth( $params['configoption1'] )) {
            throw new Exception( "api auth error" );
        }

        $api_post_fields["dv_method"] = "email=" . $approveremail . $san_emails;

        $api_post_fields["nr_domains"] = $_SESSION['cybersslcert'][ $orderID ]['san_total'] + 1;

        if ($reissue) {
            $api_post_fields["order_id"] = $orderFetch['remoteid'];
            $api_result = $api->reissue_ssl_order( $api_post_fields );
        } else {
            $api_result = $api->add_ssl_order( $api_post_fields );
        }

        if (!$api_result) {
            throw new Exception( $api->error_message );
        }
        update_query( 'tblsslorders', array( 'remoteid' => $api->response['order_id'] , 'completiondate' => 'now()', 'status' => 'Completed'), array( 'serviceid' => $params['serviceid'] ) );
        update_query( 'tblorders', array( 'status' => 'Active'), array( 'id' => $params['serviceid'] ) );
        //update_query( 'tblhosting', array( 'domainstatus' => 'Active'), array( 'id' => $params['serviceid'] ) );

       
       unset($_SESSION['cybersslcert']);

        return $returnValues;

    } catch (Exception $e) {
        _cyberssl_log("SSLStepThree",  $e->getMessage(),"error", $params["userid"]);
        logModuleCall(
            'CyberSSL',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getMessage() . "\n" . $e->getTraceAsString()
        );
        if ($e->getMessage() == "api auth error") {
            return array( 'error' => $_LANG['cyberssl_technical_error_occured'] );
        }
        if($e->getMessage() == "Not enough funds") {
            return array( 'error' => $_LANG['cyberssl_technical_error_occured'] );
        }

        return array( 'error' => $e->getMessage() );
    }
}

/**
 * AdminServicesTabFields() function will return an array with information about the order for the WHMCS adminarea.
 *
 * @param $params
 *
 * @return array
 */
function cyberssl_AdminServicesTabFields($params)
{
    try {
        $orderQuery = select_query( 'tblsslorders', '*', array( 'serviceid' => $params['serviceid'], 'status' => 'Completed' ) );

        if (mysql_num_rows( $orderQuery ) < 1) {
            return 'No Completed SSL exists for this order';
        }

        $orderFetch = mysql_fetch_assoc( $orderQuery );

        $api = new CyberSSL_api( $params['configoption2'] );
        if (!$api->auth( $params['configoption1'] )) {
            throw new Exception( "Can't connect to CyberSSL API" );
        }
        $order_status = $api->order_status( $orderFetch['remoteid'] );

        if (!$api->response_success) {
            throw new Exception( $api->error_message );
        }
            //fix invoice next date
            $certQuery = full_query( 'SELECT * FROM tblhosting WHERE id = ' . $params['serviceid'] . ' AND billingcycle IN ("Annually", "Biennially", "Triennially") LIMIT 1' );
            $certFetch = mysql_fetch_assoc( $certQuery );
            if ($order_status['status'] == 'Activated' && $certFetch) {
                $expiresDate = $order_status['valid_till'];
                full_query( 'UPDATE tblhosting SET nextduedate = "' . $expiresDate . '", nextinvoicedate = "' . $expiresDate . '" WHERE id = ' . $params['serviceid'] );
            }
            //end fix invoice next date
            $fieldsArray = array(
                'Status'        => $order_status['status'],
                'Domain'        => $order_status['primary_domain'],
                'Total Domains' => $order_status['domains_included'],
                'Product Name'  => $order_status['product']['name'],
            );

            if ($order_status['san_domains']) {
                $fieldsArray["SAN Domains"] = $order_status['san_domains'];
            }


            if (isset($order_status['order_id']) && $order_status['order_id'] != '') {
                $fieldsArray['Order Id'] = $order_status['order_id'];
            }

            if (isset($order_status['partner_order_id']) && $order_status['partner_order_id'] != '') {
                $fieldsArray['Partner Order Id'] = $order_status['partner_order_id'];
            }


            if ($order_status['status'] == 'Activated') {
                $fieldsArray['Valid From'] = $order_status['valid_from'];
                $fieldsArray['Valid Till'] = $order_status['valid_till'];

                $fieldsArray['CSR'] = '<textarea name="csr_code" rows="10" cols="80">' . $order_status['csr'] . '</textarea>';
                $fieldsArray['Certificate'] = '<textarea name="crt_code" rows="10" cols="80">' . $order_status['certificate'] . '</textarea>';
                $fieldsArray['Certificate Chain'] = '<textarea name="ca_code" rows="10" cols="80">' . $order_status['certificate_chain'] . '</textarea>';
            }

            return $fieldsArray;

    } catch (Exception $e) {
        _cyberssl_log("AdminServicesTabFields",  $e->getMessage(),"error");
        logModuleCall(
            'CyberSSL',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getMessage() . "\n" . $e->getTraceAsString()
        );
        $fieldsArray["cyberssl_module_error"] = $e->getMessage();
        return $fieldsArray;
    }
}

/**
 * AdminCustomButtonArray() function will return an array of possible actions within the WHMCS adminarea.
 */
function cyberssl_AdminCustomButtonArray()
{
    return array(
        'Cancel'                 => 'cancel',
        'Manage SSL certificate' => 'manage_ssl',
    );
}

/**
 * manage_ssl() function will pass the admin to the clientarea, because this is more stable.
 *
 * @param $params
 */
function cyberssl_manage_ssl($params)
{
    global $CONFIG;
    echo '<center>Redirecting.. Please wait.</center><script> window.location = "' . (($CONFIG['SystemSSLURL'] == '') ? $CONFIG['SystemURL'] : $CONFIG['SystemSSLURL']) . '/dologin.php?username=' . get_query_val( 'tblclients', 'email', array( 'id' => $params['userid'] ) ) . '&goto=' . urlencode( 'clientarea.php?action=productdetails&id=' . $params['serviceid'] ) . '"; </script>';
    exit();
}

/**
 * cancel() function will cancel an incomplete SSL order within WHMCS from the adminarea.
 *
 * @param $params
 *
 * @return string
 */
function cyberssl_cancel($params)
{
    try {
        $orderQuery = full_query( 'SELECT * FROM tblsslorders WHERE serviceid = ' . $params['serviceid'] . ' AND (status = "Incomplete" OR status = "Awaiting Configuration")' );

        if (mysql_num_rows( $orderQuery ) < 1) {
            throw new Exception( $_LANG['cyberssl_no_certificate_exists'] );
        }

        update_query( 'tblsslorders', array( 'status' => 'Cancelled' ), array( 'serviceid' => $params['serviceid'] ) );
    } catch (Exception $e) {
        _cyberssl_log("cancel",  $e->getMessage(),"error", $params["userid"]);
        logModuleCall(
            'CyberSSL',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getMessage() . "\n" . $e->getTraceAsString()
        );

        return $e->getMessage();

    }

    return 'success';
}


/**
 * ClientAreaCustomButtonArray() function will return an array with available actions for the clientarea.
 *
 * @param $params
 *
 * @return array
 */
function cyberssl_ClientAreaCustomButtonArray($params)
{
    global $_LANG;

    try {

        
        $orderQuery = select_query( 'tblsslorders', '*', array( 'serviceid' => $params['serviceid'] ) ); //, 'status' => 'Completed')

        if (mysql_num_rows( $orderQuery ) < 1) {
            $buttonArray[ $_LANG['cyberssl_resend_conf'] ] = 'resend_conf';

            return $buttonArray;
        }

        $orderFetch = mysql_fetch_assoc( $orderQuery );

        $api = new CyberSSL_api( $params['configoption2'] );
        if (!$api->auth( $params['configoption1'] )) {
            throw new Exception( "api auth error" );
        }
        $statusResult = $api->order_status( $orderFetch['remoteid'] );

        if (!isset($api->response_success)) {
            throw new Exception( $api->error_message );
        }

        if ($statusResult["status"] == 'Activated' && $orderFetch["status"] == "Awaiting Configuration") {
            $buttonArray[ $_LANG['cyberssl_cancel_reissue'] ] = 'CancelReissue';
        } elseif ($statusResult['status'] == 'Awaiting Validation') {
            $buttonArray[ $_LANG['cyberssl_resend_dv_email'] ] = 'DvResend';
            $buttonArray[ $_LANG['cyberssl_change_dv_method'] ] = 'ChangeDvMethod';
        } elseif ($statusResult['status'] == 'Activated') {
            $buttonArray[ $_LANG['cyberssl_reissue'] ] = 'reissue';
        }

        return $buttonArray;

    } catch (Exception $e) {
        _cyberssl_log("ClientAreaCustomButtonArray",  $e->getMessage(),"error", $params["userid"]);
        logModuleCall(
            'CyberSSL',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getMessage() . "\n" . $e->getTraceAsString()
        );

        return array();

    }
}

function cyberssl_reissue($params)
{
    global $CONFIG;


    $orderQuery = full_query( 'SELECT * FROM tblsslorders WHERE serviceid = ' . $params['serviceid'] . ' AND (status = "Incomplete" OR status = "Awaiting Configuration" OR status = "Completed")' );

    if (mysql_num_rows( $orderQuery ) < 1) {
        return $_LANG['cyberssl_page_not_found_desc'];
    }


    $data = mysql_fetch_assoc( $orderQuery );

    full_query( "UPDATE tblsslorders SET status='Awaiting Configuration' WHERE id='" . (int)$data['id'] . "'" );
    
    return 'success';
    
    echo $CONFIG["SystemURL"] . "/configuressl.php?cert=" . md5( $data['id'] ) ;       
    echo '<br>';
    echo '<center>Redirecting.. Please wait.</center><script> window.location = "' . $CONFIG["SystemURL"] . "/configuressl.php?cert=" . md5( $data['id'] ) . '"; </script>';
    //http://whmcs.cyberssl.com/clientarea.php?action=productdetails&id=16    
    
    exit();
}

function cyberssl_CancelReissue($params)
{

    $orderQuery = full_query( 'SELECT * FROM tblsslorders WHERE serviceid = ' . $params['serviceid'] . ' AND (status = "Incomplete" OR status = "Awaiting Configuration" OR status = "Completed")' );

    if (mysql_num_rows( $orderQuery ) < 1) {
        return $_LANG['cyberssl_page_not_found_desc'];
    }


    $data = mysql_fetch_assoc( $orderQuery );

    full_query( "UPDATE tblsslorders SET status='Completed' WHERE id='" . (int)$data['id'] . "'" );

    return 'success';

}

/**
 * resend_val() function will being called when the "resend_val" button has been pressed, this will resend the validation email.
 *
 * @param $params
 *
 * @return string
 */
function cyberssl_DvResend($params)
{
    global $_LANG;

    try {
        $orderQuery = select_query( 'tblsslorders', '*', array( 'serviceid' => $params['serviceid'], 'status' => 'Completed' ) );

        if (mysql_num_rows( $orderQuery ) < 1) {
            throw new Exception( $_LANG['cyberssl_no_certificate_exists'] );
        }

        $orderFetch = mysql_fetch_assoc( $orderQuery );

        $api = new CyberSSL_api( $params['configoption2'] );
        if (!$api->auth( $params['configoption1'] )) {
            throw new Exception( "api auth error" );
        }

        if (!$api->resend_dv_email( $orderFetch['remoteid'] )) {
            throw new Exception( $api->error_message );
        }
    } catch (Exception $e) {
        _cyberssl_log("DvResend",  $e->getMessage(),"error", $params["userid"]);
        logModuleCall(
            'CyberSSL',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getMessage() . "\n" . $e->getTraceAsString()
        );
        if ($e->getMessage() == "api auth error") {
            return ". ".$_LANG['cyberssl_technical_error_occured'];
        }

        return ". ".$_LANG['cyberssl_error_occured'].$e->getMessage();
    }

    return 'success';
}

/**
 * Renew() function will being called when the renew invoice has been paid.
 * function cyberssl_Renew($params) {
 * global $CONFIG, $_LANG;
 * $orderQuery = select_query('tblsslorders', '*', array('serviceid' => $params['serviceid'], 'status' => 'Completed'));
 * if (mysql_num_rows($orderQuery) < 1) {
 * logActivity('CyberSSL Renew error: Could not find completed order; serviceid: ' . $params['serviceid']);
 * return;
 * }
 * $orderFetch = mysql_fetch_assoc($orderQuery);
 * $api = new CyberSSL_api($packageconfigoption[2]);
 * if(!$api->auth($packageconfigoption[1])) {
 * return $_LANG['cyberssl_technical_error_occured'];
 * }
 * $api->order_status($order_id);
 * if (!$api->response_success) {
 * logActivity('CyberSSL Renew error: Received error on getting order status; description: ' . $api->error_message);
 * return;
 * }
 * $postFields['product_id'] = $orderFetch['product_id'];
 * $postFields['csr'] = $statusResult['csr_code'];
 * $postFields['period'] = _cyberssl_GetPeriod ((int)$params['serviceid']);
 * $postFields["dv_method"] =  "email=".$statusResult['approver_email'];
 * if($statusResult['san_approver_emails']) { $postFields["dv_method"].=",".$statusResult['san_approver_emails']; }
 * $postFields['software_id'] = $statusResult['software_id'];
 * $postFields["nr_domains"] = $statusResult['domains_included'];
 * if($reissue) { $api_post_fields["order_id"]=$orderFetch['remoteid']; $api_result=$api->reissue_ssl_order($api_post_fields); }
 * else { $api_result=$api->add_ssl_order($api_post_fields); }
 * $prefix = array('tech', 'org', 'admin');
 * foreach ($statusResult["contacts"] as $k => $v) {
 * if (in_array($keySplit[0], $prefix)) {
 * $postFields[$k] = $v;
 * }
 * }
 * $renewResult = cyberssl_call($postFields, $params['configoption5']);
 * if (isset($renewResult['error'])) {
 * logActivity('CyberSSL Renew error: Received error on renewing SSL; description: ' .$api->error_message);
 * return;
 * }
 * update_query('tblsslorders', array('remoteid' => $renewResult['order_id'], 'completiondate' => 'now()', 'status' => 'Completed'), array('serviceid' => $params['serviceid']));
 * logActivity('CyberSSL Renew sucessful: Created renew requests successfully; serviceid: ' . $params['serviceid']);
 * }
 */
/**
 * @param $params
 * @param $statusResult
 * @param $orderFetch
 *
 * @return array|string
 */
function cyberssl_page_change_dv_method($params, $statusResult, $orderFetch)
{
    global $CONFIG, $_LANG;
    try {
        if ($statusResult['status'] == 'Awaiting Validation') {

            $api = new CyberSSL_api( $params['configoption2'] );
            if (!$api->auth( $params['configoption1'] )) {
                throw new Exception( "api auth error" );
            }

            if (isset($_POST['submit'])) {

                $validationMethods = array( 'dns', 'http', 'https' );

                if (isset($_POST['validation_method']) && in_array( $_POST['validation_method'], $validationMethods )) {

                    switch ($_POST['validation_method']) {

                        case 'dns':
                            $post_fields["dv_method"] = "dns";
                            break;

                        case 'https':
                            $post_fields["dv_method"] = "https";
                            break;

                        case 'http':
                        default:
                            $post_fields["dv_method"] = "http";
                            break;

                    }

                } else {
                    $post_fields["dv_method"] = "email";
                    $post_fields["email"] = $_POST['approver_email'];
                    $statusResult["approver_email"] = $post_fields["email"];//change the approver_email in currect order array
                    if ($statusResult["san_domains"]) {
                        $san_domains = explode( ",", $statusResult["san_domains"] );
                        foreach ($san_domains as $key => $domain ) {
                            $san_emails[] = $_POST["approver_email_".$key];
                        }
                        $post_fields["san_emails"] = implode(",", $san_emails );
                    }
                }
                $post_fields['order_id'] = $orderFetch['remoteid'];

                $api->change_dv_method( $post_fields );

                if (!$api->response_success) {
                    throw new Exception( $api->error_message );
                } else {
                    $statusResult["dv_method"] = $post_fields["dv_method"]; //change the dv_method in currect order array
                }
            }

            $dv_options = $api->get_dv_options( array(
                'dv_method' => "all",
                'order_id'  => $orderFetch['remoteid'],
            ) );
            if (!$api->response_success) {
                throw new Exception( $api->error_message );
            }
            $allApproverEmails = $dv_options["email"];

            return array(
                'templatefile' => 'templates/change_dv_method',
                'vars'         => array(
                    'cyberssl_order'           => $statusResult,
                    'cyberssl_product'         => $statusResult["product"],
                    'cyberssl_approver_emails' => $allApproverEmails,
                    'dv_options'               => $dv_options
                )
            );
        } else {

            header( 'location: ' . (($CONFIG['SystemSSLURL'] == '') ? $CONFIG['SystemURL'] : $CONFIG['SystemSSLURL']) . '/clientarea.php?action=productdetails&id=' . $params['serviceid'] );
            exit();

        }
    } catch (Exception $e) {
        _cyberssl_log("page_change_dv_method",  $e->getMessage(),"error", $params["userid"]);
        logModuleCall(
            'CyberSSL',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getMessage() . "\n" . $e->getTraceAsString()
        );
        if ($e->getMessage() == "api auth error") {
            $error_message = $_LANG['cyberssl_technical_error_occured'];
        } else {
            $error_message = $e->getMessage();
        }

        return array(
            'templatefile' => 'templates/notification',
            'vars'         => array(
                'status'      => 'error',
                'title'       => $_LANG['cyberssl_error_occured'],
                'description' => $error_message
            )
        );
    }
}

/**
 * @param $params
 */
function cyberssl_ChangeDvMethod($params)
{
    global $CONFIG;
    header( 'location: ' . (($CONFIG['SystemSSLURL'] == '') ? $CONFIG['SystemURL'] : $CONFIG['SystemSSLURL']) . '/clientarea.php?action=productdetails&id=' . $params['serviceid'] . '&custom_page=change_dv_method' );
    exit();
}

function _cyberssl_GetPeriod($serviceId)
{
    $cycles = array( 'Annually' => 1, 'Biennially' => 2, 'Triennially' => 3 );
    $service = mysql_fetch_assoc( mysql_query( 'select * from tblhosting where id = "' . $serviceId . '"' ) );
    $certyears_recurring = $cycles[ $service['billingcycle'] ];

    if ($certyears_recurring) {
        return $certyears_recurring;
    } else {
        return 1;                         //$params['configoption4']
    }
}
