<b xmlns="http://www.w3.org/1999/html" style="font-size:18px;">
	{$LANG.cyberssl_choose_dv_method_for} {$cyberssl_order.primary_domain}:
</b>
<br /><br />
<form action="" method="POST">
	{if $cyberssl_product.brand == 'comodo'}
	<div class="row-fluid" style="text-align:center">
		<table align="center">
			<tr>
      	        <td style="padding-left:10px;">
					<input type="radio" name="validation_method" id="validation_email" value="email" {if $cyberssl_order.dv_method == 'email'}checked{/if}>
					<label for="validation_email">{$LANG.cyberssl_email_validation}</label>
				</td>
				<td style="padding-left:10px;">
					<input type="radio" name="validation_method" id="validation_dns" value="dns" {if $cyberssl_order.dv_method == 'dns'}checked{/if}>
					<label for="validation_dns">{$LANG.cyberssl_dns_validation}</label>
				</td>
				<td style="padding-left:10px;">
					<input type="radio" name="validation_method" id="validation_http" value="http" {if $cyberssl_order.dv_method == 'http'}checked{/if}>
					<label for="validation_http">{$LANG.cyberssl_http_validation}</label>
				</td>
				<td style="padding-left:10px;">
					<input type="radio" name="validation_method" id="validation_https" value="https" {if $cyberssl_order.dv_method == 'https'}checked{/if}>
					<label for="validation_https">{$LANG.cyberssl_https_validation}</label>
				</td>
			</tr>
		</table>

	</div>
	<br/>
	{/if}

	<fieldset class="onecol"{if $cyberssl_product.brand == 'comodo'} id="validation_email_fields" style="display: none;"{/if}>
		{if $dv_options.email}
			<div class="control-group">
				<label class="control-label" for="approver_email">{$LANG.cyberssl_approver_email_for} {$cyberssl_order.primary_domain}</label>
				<div class="controls">
					<select style="width:300px;" name="approver_email" id="approver_email">
					<option value="" selected disabled>{$LANG.pleasechooseone}</option>
						{foreach from=$cyberssl_approver_emails[$cyberssl_order.primary_domain] item=email_value}<option value="{$email_value}"{if $cyberssl_order.approver_email eq $email_value} selected{/if}>{$email_value}</option>{/foreach}
					</select>
				</div>
			</div>
			{if $cyberssl_order.san_domains != ''}
				{assign var=domains value=','|explode:$cyberssl_order.san_domains}
				{assign var=san_approver_emails value=','|explode:$cyberssl_order.san_approver_emails}

				{foreach from=$domains key=i item=domain}
					<label class="control-label" for="approver_email_{$i}">{$LANG.cyberssl_approver_email_for} {$domain}</label>
					<div class="controls">
						<select style="width:300px;" name="approver_email_{$i}" id="approver_email_{$i}">
							<option value="" selected disabled>{$LANG.pleasechooseone}</option>
							{foreach from=$cyberssl_approver_emails[$domain] item=email_value}<option value="{$email_value}"{if $san_approver_emails[$i] eq $email_value} selected{/if}>{$email_value}</option>{/foreach}
						</select>
					</div>
				{/foreach}
			{/if}
		{else}
			<center>{$LANG.cyberssl_click_continue}</center><br/>
		{/if}

	</fieldset>

	{if $cyberssl_product.brand == 'comodo'}
	<fieldset class="onecol" id="validation_dns_fields" style="display: none;">

		{if $dv_options.dns}
			<div class="control-group">
				<label class="control-label">{if $cyberssl_order.primary_domain != ''}{$LANG.cyberssl_dns_record_for} {$cyberssl_order.primary_domain}{else}{$LANG.cyberssl_dns_record}{/if}</label>
				<div class="controls">
					{$dv_options.dns[$cyberssl_order.primary_domain].record}
				</div>
			</div>

			{if $cyberssl_order.san_domains != ''}
				{assign var=domains value=','|explode:$cyberssl_order.san_domains}

				{foreach from=$domains item=domain}
					<div class="control-group">
						<label class="control-label">{$LANG.cyberssl_dns_record_for} {$domain}</label>
						<div class="controls">
							{$dv_options.dns[$domain].record}
						</div>
					</div>
				{/foreach}
			{/if}
		{else}
			<center>{$LANG.cyberssl_click_continue}</center><br/>
		{/if}

	</fieldset>
	<fieldset class="onecol" id="validation_http_fields" style="display: none;">
		{if $dv_options.http}
			<center><strong>{$LANG.cyberssl_upload_this_file}</strong></center>
			<center>{$dv_options.http[$cyberssl_order.primary_domain].link}</center><br />
			<div class="control-group">
				<label class="control-label">{$LANG.cyberssl_file_name}</label>
				<div class="controls">
						{$dv_options.http[$cyberssl_order.primary_domain].filename}
				</div>
			</div>
			<div class="control-group">
				<label class="control-label">{$LANG.cyberssl_file_content}</label>
				<div class="controls">
					<textarea style="width: 390px; height: 70px;">{$dv_options.http[$cyberssl_order.primary_domain].content}</textarea>
				</div>
			</div>
		{else}
			<center>{$LANG.cyberssl_click_continue}</center><br/>
		{/if}

	</fieldset>

    <fieldset class="onecol" id="validation_https_fields" style="display: none;">
		{if $dv_options.https}
			<center><strong>{$LANG.cyberssl_upload_this_file}</strong></center>
			<center>{$dv_options.https[$cyberssl_order.primary_domain].link}</center><br />
            <div class="control-group">
                <label class="control-label">{$LANG.cyberssl_file_name}</label>
                <div class="controls">
                    {$dv_options.https[$cyberssl_order.primary_domain].filename}
                </div>
            </div>
            <div class="control-group">
                <label class="control-label">{$LANG.cyberssl_file_content}</label>
                <div class="controls">
                    <textarea style="width: 390px; height: 70px;">{$dv_options.https[$cyberssl_order.primary_domain].content}</textarea>
                </div>
            </div>
        {else}
            <center>{$LANG.cyberssl_click_continue}</center><br/>
        {/if}
    </fieldset>
	{/if}
	<br />
	<p align="center"><a class="btn" href="clientarea.php?action=productdetails&id={$smarty.get.id}"> {$LANG.cyberssl_go_back}</a>&nbsp;<input type="submit" name="submit" value="{$LANG.ordercontinuebutton}" class="btn btn-primary" /></p>
</form>

{if $cyberssl_product.brand == 'comodo'}
{literal}
<script>
$(function() {
    $('input[name=validation_method]').change(function() {
		$('.onecol').hide();
		$('#' + $(this).attr('id') + '_fields').show();
    });
	$('#' + $('input[name=validation_method]:checked').attr('id') + '_fields').show();
});
</script>
{/literal}
{/if}
