{if $cyberssl_order.primary_domain neq ''}
<h2>
	{$LANG.cyberssl_certificate_details_for} {$cyberssl_order.primary_domain}
</h2>
{else}
<h2>
	{$LANG.cyberssl_certificate_details}
</h2>
{/if}

{literal} 
<style>
.fieldarea{
	font-weight: bold;
}
</style>
{/literal} 

<table align="center">
	<tbody>
		<tr>
			<td class="fieldarea">
				{$LANG.cyberssl_status}
			</td>
			<td style="padding: 5px;">
				{$cyberssl_status}
			</td>
		</tr>
		{if $cyberssl_order.status_description != '' && $cyberssl_status != $cyberssl_order.status_description}
		<tr>
			<td class="fieldarea">
				{$LANG.cyberssl_status_description}
			</td>
			<td style="padding: 5px;">
				{$cyberssl_order.status_description}
			</td>
		</tr>
		{/if}
		{if $cyberssl_order.status eq "Activated"}
		<tr>
			<td class="fieldarea">
				{$LANG.cyberssl_valid_from}
			</td>
			<td style="padding: 5px;">
				<b>
					{$cyberssl_order.valid_from}
				</b>
			</td>
		</tr>
		<tr>
			<td class="fieldarea">
				{$LANG.cyberssl_valid_till}
			</td>
			<td style="padding: 5px;">
				<b>
					{$cyberssl_order.valid_till}
				</b>
			</td>
		</tr>
		{/if}
		{if $cyberssl_order.domain != ''}
			<tr>
				<td class="fieldarea">
					{$LANG.cyberssl_domain}
				</td>
				<td style="padding: 5px;">
					{$cyberssl_order.domain}
				</td>
			</tr>
		{/if}
		{if $cyberssl_order.san_domains != ''}
		<tr>
			<td class="fieldarea">
				{$LANG.cyberssl_san_domains}
			</td>
			<td style="padding: 5px;">
				{assign var=domains value=','|explode:$cyberssl_order.san_domains}
				
				{foreach from=$domains item=domain}
					{$domain}<br/>
				{/foreach}
			</td>
		</tr>
		{/if}
		{if $cyberssl_order.dv_method != ''}
			<tr>
				<td class="fieldarea">
					{$LANG.cyberssl_dv_method}
				</td>
				<td style="padding: 5px;text-transform: uppercase">
					{$cyberssl_order.dv_method}
				</td>
			</tr>
		{/if}
		{if $cyberssl_order.san_approver_emails != '' || $cyberssl_order.approver_email != ''}
			<tr>
				<td class="fieldarea">
					{$LANG.cyberssl_approver_email}
				</td>
				<td style="padding: 5px;text-align:center;">
                    {if $cyberssl_order.san_approver_emails != ''}  
                        {$cyberssl_order.approver_email}<br/>
                        {assign var=approver_emails value=','|explode:$cyberssl_order.san_approver_emails}

                        {foreach from=$approver_emails item=approver_email}
                            {$approver_email}<br/>
                        {/foreach}
                    {else}
                        {$cyberssl_order.approver_email}
                    {/if}
				</td>
			</tr>
		{/if}
		{if $cyberssl_order.partner_order_id != '' &&
		( $cyberssl_order.product.validation_type == 'ev' || $cyberssl_order.product.validation_type == 'bv' )}
			<tr>
				<td class="fieldarea">
					<span style="text-transform: capitalize">{$cyberssl_order.product.brand}</span>
					{$LANG.cyberssl_partner_order_id}
				</td>
				<td style="padding: 5px;">
					{$cyberssl_order.partner_order_id}
				</td>
			</tr>
		{/if}
		{if $cyberssl_order.status eq 'Activated'}
            <tr>
                <td class="fieldarea">
                    {$LANG.cyberssl_crt_code}
                </td>
                <td style="padding: 5px;">
                    <textarea rows="10" cols="100" style="font-size:12px; font-family:Courier; margin: 0px 0px 9px; width: 470px; height: 200px;">{$cyberssl_order.certificate}</textarea>
                </td>
            </tr>
            <tr>
                <td class="fieldarea">
                    {$LANG.cyberssl_ca_code}
                </td>
                <td style="padding: 5px;">
                    <textarea rows="10" cols="100" style="font-size:12px;font-family:Courier;  margin: 0px 0px 9px; width: 470px; height: 200px;">{$cyberssl_order.certificate_chain}</textarea>
                </td>
            </tr>
		{/if}
        {if $cyberssl_raw_status eq 'awaiting_configuration'}
            <tr>
                <td colspan="2">
                    <a class="btn" href="{$configuration_url}"> <i class="icon icon-cog"></i> {$LANG.cyberssl_goto_conf}</a>
                </td>
            </tr>
        {/if}
	</tbody>
</table>
